require 'spec_helper'
require 'fileutils'

describe Guard::Pumadev::Manager do
  let(:manager) { Guard::Pumadev::Manager.new }

  before {
    Guard::UI.stub(:info)
    Guard::Notifier.stub(:notify)
  }

  describe "#restart_pumadev" do

    context "without tmp dir" do
      before { FileUtils.rm_rf('tmp') }

      it "creates and removes tmp/restart.txt" do
        manager.restart
        expect(File.file?("tmp/restart.txt")).to be_falsey
      end
    end

    context "with tmp dir" do
      before {
        FileUtils.mkdir 'tmp' unless File.directory?("tmp")
        FileUtils.rm_rf('tmp/restart.txt')
      }

      it "creates tmp/restart.txt" do
        manager.restart
        expect(File.file?("tmp/restart.txt")).to be_falsey
      end
    end

    context "with tmp dir" do
      before {
        FileUtils.mkdir 'tmp' unless File.directory?("tmp")
        FileUtils.touch('tmp/restart.txt')
        sleep 1
      }

      it "touches tmp/restart.txt" do
        manager.restart
        expect(File.file?("tmp/restart.txt")).to be_falsey 
      end
    end
  end

end
